#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program  
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
# 
#-------------------------------------------------------------------------------------------------
from twisted.spread.pb import Error

class NativeMPIOError(Error):
    def __init__(self, *args, **kwargs):
        Exception.__init__(self, *args, **kwargs)

class NativeMPIONotReadyError(NativeMPIOError): pass

class SetLBPolicyFailedError(NativeMPIOError):
    def __init__(self, device, policy, msg=""):
        NativeMPIOError.__init__(self, "failed to set load balancing policy %s for device %s (error %s)" % (policy, device, msg))

class NativeMPIO(object):
    def set_load_balancing_policy(self, physical_device_id, policy):
        raise NotImplementedError, "abstract"

    def query_snapshot(self):
        raise NotImplementedError, "abstract"
