#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#-------------------------------------------------------------------------------------------------

import win32api
import win32process
import win32con

from common.agent.config import config, PRIORITIES

PRIORITY_CLASSES = { PRIORITIES['IDLE']: win32process.IDLE_PRIORITY_CLASS,
                     PRIORITIES['BELOW_NORMAL']: win32process.BELOW_NORMAL_PRIORITY_CLASS,
                     PRIORITIES['NORMAL']: win32process.NORMAL_PRIORITY_CLASS,
                     PRIORITIES['ABOVE_NORMAL']: win32process.ABOVE_NORMAL_PRIORITY_CLASS,
                     PRIORITIES['HIGH']: win32process.HIGH_PRIORITY_CLASS,
                     PRIORITIES['REALTIME']: win32process.REALTIME_PRIORITY_CLASS }

def set_process_priority():
    pid = win32api.GetCurrentProcessId()
    handle = win32api.OpenProcess(win32con.PROCESS_ALL_ACCESS, True, pid)
    win32process.SetPriorityClass(handle, PRIORITY_CLASSES[config.priority])
